Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Namespace UI_Classic_Sample
    <ProgIdAttribute("UI_Classic_Sample.StandardAddInServer"), _
    GuidAttribute("3ff095f0-8eff-4cd0-b6a3-ac06556c3777")> _
    Public Class StandardAddInServer
        Implements Inventor.ApplicationAddInServer

        ' Inventor application object.
        Private m_inventorApplication As Inventor.Application

        Private WithEvents m_appEvents As Inventor.ApplicationEvents
        Private WithEvents m_button1Def As Inventor.ButtonDefinition
        Private WithEvents m_button2Def As Inventor.ButtonDefinition
        Private WithEvents m_button3Def As Inventor.ButtonDefinition
        Private WithEvents m_button4Def As Inventor.ButtonDefinition
        Private WithEvents m_button5Def As Inventor.ButtonDefinition
        Private WithEvents m_button6Def As Inventor.ButtonDefinition
        Private m_macroButtonDef As Inventor.MacroControlDefinition


#Region "ApplicationAddInServer Members"

        Public Sub Activate(ByVal addInSiteObject As Inventor.ApplicationAddInSite, ByVal firstTime As Boolean) Implements Inventor.ApplicationAddInServer.Activate
            ' Initialize AddIn members.
            m_inventorApplication = addInSiteObject.Application

            ' Create the control definitions.
            Dim controlDefs As ControlDefinitions = m_inventorApplication.CommandManager.ControlDefinitions
            Dim picture As stdole.IPictureDisp
            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.One)
            m_button1Def = controlDefs.AddButtonDefinition("One", "UISampleOne", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.Two)
            m_button2Def = controlDefs.AddButtonDefinition("Two", "UISampleTwo", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.Three)
            m_button3Def = controlDefs.AddButtonDefinition("Three", "UISampleThree", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.Four)
            m_button4Def = controlDefs.AddButtonDefinition("Four", "UISampleFour", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.Five)
            m_button5Def = controlDefs.AddButtonDefinition("Five", "UISampleFive", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            picture = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(My.Resources.Six)
            m_button6Def = controlDefs.AddButtonDefinition("Six", "UISampleSix", CommandTypesEnum.kNonShapeEditCmdType, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}", , , picture)

            ' Create a command category and add the buttons to the category.
            Dim cmdCategory As CommandCategory
            cmdCategory = m_inventorApplication.CommandManager.CommandCategories.Add("Classic UI Demo", "UISample", "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}")
            cmdCategory.Add(m_button1Def)
            cmdCategory.Add(m_button2Def)
            cmdCategory.Add(m_button3Def)
            cmdCategory.Add(m_button4Def)
            cmdCategory.Add(m_button5Def)
            cmdCategory.Add(m_button6Def)

            If firstTime Then
                ' Create a macro control definition.  This is done within the first time statement instead of 
                ' with the other definition creation because it only needs to be created once and Inventor will
                ' handle calling the macro on it's own without the Add-In needing to respond.  The button that's
                ' created for this macro will only work correctly if there's a module in the application project called
                ' "Module1" and there's a public sub in that module called "Test" that does not have any arguments.
                m_macroButtonDef = controlDefs.AddMacroControlDefinition("Module1.Test")


                ' Get the assembly environment.
                Dim UIManager As Inventor.UserInterfaceManager = m_inventorApplication.UserInterfaceManager
                Dim asmEnvironment As Environment
                asmEnvironment = UIManager.Environments.Item("AMxAssemblyEnvironment")

                ' Add a button to the assembly panel bar.
                Dim asmPanel As Inventor.CommandBar = asmEnvironment.PanelBar.DefaultCommandBar
                asmPanel.Controls.AddButton(m_button1Def)

                ' Add a button to the main tool bar of the assembly environment.
                asmEnvironment.DefaultToolBar.Controls.AddButton(m_button2Def)

                ' Add a button to the File menu right after the Close button.
                Dim fileBar As CommandBar = asmEnvironment.DefaultMenuBar.Controls.Item("AssemblyFileMenu").CommandBar
                fileBar.Controls.AddButton(m_button3Def, fileBar.Controls.Item("AppFileCloseCmd").index + 1)

                ' Add a button to the Help menu at the bottom.
                Dim helpBar As CommandBar = asmEnvironment.DefaultMenuBar.Controls.Item("AppHelpMenu").CommandBar
                Dim additionalResourceButtonBar As CommandBar = helpBar.Controls.Item("AppHelpAdditionalResourcesMenu").CommandBar
                additionalResourceButtonBar.Controls.AddButton(m_button4Def)

                ' Create a regular command bar and add two buttons to it.
                Dim commandBar As CommandBar
                commandBar = UIManager.CommandBars.Add("Inventor Classic User Interface Demo", "UISampleRegular", CommandBarTypeEnum.kRegularCommandBar, "{3ff095f0-8eff-4cd0-b6a3-ac06556c3777}")
                commandBar.Controls.AddButton(m_button5Def)
                commandBar.Controls.AddButton(m_button6Def)

                ' Make the command bar visible.
                commandBar.Visible = True

                ' Add the new command bar to the panel bar list.
                asmEnvironment.PanelBar.CommandBarList.Add(commandBar)
            End If
        End Sub

        Public Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate
            ' Release objects.
            Marshal.ReleaseComObject(m_button1Def)
            m_button1Def = Nothing

            Marshal.ReleaseComObject(m_button2Def)
            m_button2Def = Nothing

            Marshal.ReleaseComObject(m_button3Def)
            m_button3Def = Nothing

            Marshal.ReleaseComObject(m_button4Def)
            m_button4Def = Nothing

            Marshal.ReleaseComObject(m_button5Def)
            m_button5Def = Nothing

            Marshal.ReleaseComObject(m_button6Def)
            m_button6Def = Nothing

            Marshal.ReleaseComObject(m_macroButtonDef)
            m_macroButtonDef = Nothing

            Marshal.ReleaseComObject(m_appEvents)
            m_appEvents = Nothing

            Marshal.ReleaseComObject(m_inventorApplication)
            m_inventorApplication = Nothing

            System.GC.WaitForPendingFinalizers()
            System.GC.Collect()

        End Sub

        Public ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation
            Get
                Return Nothing
            End Get
        End Property

        Public Sub ExecuteCommand(ByVal commandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand
        End Sub

#End Region

#Region "COM Registration"

        ' Registers this class as an AddIn for Inventor.
        ' This function is called when the assembly is registered for COM.
        <ComRegisterFunctionAttribute()> _
        Public Shared Sub Register(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing
            Dim subKey As RegistryKey = Nothing

            Try
                clsid = clssRoot.CreateSubKey("CLSID\" + AddInGuid(t))
                clsid.SetValue(Nothing, "Classic UI Demo")
                subKey = clsid.CreateSubKey("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                subKey.Close()

                subKey = clsid.CreateSubKey("Settings")
                subKey.SetValue("AddInType", "Standard")
                subKey.SetValue("LoadOnStartUp", "1")

                'subKey.SetValue("SupportedSoftwareVersionLessThan", "")
                subKey.SetValue("SupportedSoftwareVersionGreaterThan", "12..")
                'subKey.SetValue("SupportedSoftwareVersionEqualTo", "")
                'subKey.SetValue("SupportedSoftwareVersionNotEqualTo", "")
                'subKey.SetValue("Hidden", "0")
                'subKey.SetValue("UserUnloadable", "1")
                subKey.SetValue("Version", 1)
                subKey.Close()

                subKey = clsid.CreateSubKey("Description")
                subKey.SetValue(Nothing, "Demonstrates all of the UI functionality in the ""classic"" interface.")

            Catch ex As Exception
                System.Diagnostics.Trace.Assert(False)
            Finally
                If Not subKey Is Nothing Then subKey.Close()
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' Unregisters this class as an AddIn for Inventor.
        ' This function is called when the assembly is unregistered.
        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub Unregister(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing

            Try
                clssRoot = Microsoft.Win32.Registry.ClassesRoot
                clsid = clssRoot.OpenSubKey("CLSID\" + AddInGuid(t), True)
                clsid.SetValue(Nothing, "")
                clsid.DeleteSubKeyTree("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                clsid.DeleteSubKeyTree("Settings")
                clsid.DeleteSubKeyTree("Description")
            Catch
            Finally
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' This property uses reflection to get the value for the GuidAttribute attached to the class.
        Public Shared ReadOnly Property AddInGuid(ByVal t As Type) As String
            Get
                Dim guid As String = ""
                Try
                    Dim customAttributes() As Object = t.GetCustomAttributes(GetType(GuidAttribute), False)
                    Dim guidAttribute As GuidAttribute = CType(customAttributes(0), GuidAttribute)
                    guid = "{" + guidAttribute.Value.ToString() + "}"
                Finally
                    AddInGuid = guid
                End Try
            End Get
        End Property

#End Region

        Private Sub m_button1Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button1Def.OnExecute
            MsgBox("Button 1 executed")
        End Sub

        Private Sub m_button2Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button2Def.OnExecute
            MsgBox("Button 2 executed")
        End Sub

        Private Sub m_button3Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button3Def.OnExecute
            MsgBox("Button 3 executed")
        End Sub

        Private Sub m_button4Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button4Def.OnExecute
            MsgBox("Button 4 executed")
        End Sub

        Private Sub m_button5Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button5Def.OnExecute
            MsgBox("Button 5 executed")
        End Sub

        Private Sub m_button6Def_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_button6Def.OnExecute
            MsgBox("Button 6 executed")
        End Sub
    End Class

End Namespace

